## Make the fourplots for each file.
## R CMD BATCH make_fourplots.R
require(rhdf5)
require(sjemea)
require(parallel)
options(mc.cores = 10)

WAVEREPO <- Sys.getenv("WAVEREPO_ROOT")
hdf5.root <- paste0(WAVEREPO, "hdf5/")

h5.files <- list.files(path=hdf5.root, pattern='.h5',
                       full.names=TRUE, recursive=TRUE)

## Do we want to find a subset.
find.subset <- TRUE
if (find.subset) {
  matching <- grep('Maccione2014/', h5.files )
  h5.files <- h5.files[matching]
}

stopifnot(length(h5.files)>0)
fourplot.dir <- paste0(WAVEREPO, "fourplot/")
## make the directory if doesn't exist.
if (! file.exists(fourplot.dir))  { dir.create(fourplot.dir) }


make.fourplot <- function(h5file, fourplot.dir) {
  ## Read in the h5file, and stick fourplot png in fourplot.dir, under key.

  key <- h5read(h5file, "/meta/key")

  key
  f.dir <- paste0(fourplot.dir, key, "/")
  f.dir
  if (! file.exists(f.dir))  { dir.create(f.dir) }
  s <- h5.read.spikes(h5file)
  pngfile <- paste0(f.dir, basenamepy(h5file)$base, ".png")

##  return(pngfile)
  
  png(file=pngfile, width=800, height=600)
  fourplot(s)
  dev.off()
  pngfile
}

##s <- make.fourplot(h5.files[2], fourplot.dir)

pngs <- mclapply(h5.files, function(f) {make.fourplot(f, fourplot.dir)})
  

